![logo](media/image1.png)

|oneM2M<br/>Technical Specification |oneM2M<br />Technical Specification |
|-|-|
|Document Number |TS-0041-V-5.0.0 |
|Document Name: |oneM2M-SensorThings Interworking<br /> |
|Date: |2024-03-01 |
|Abstract: |&lt; An abstract of the specification and information that may be used in subsequent electronic searches> |
|Template Version: | January 2020 (do not modify) |


The present document is provided for future development work within oneM2M only. The Partners accept no liability for any use of this specification.

The present document has not been subject to any approval process by the oneM2M Partners Type 1.  Published oneM2M specifications and reports for implementation should be obtained via the oneM2M Partners' Publications Offices.


<br />About oneM2M

The purpose and goal of oneM2M is to develop technical specifications which address the need for a common M2M Service Layer that can be readily embedded within various hardware and software, and relied upon to connect the myriad of devices in the field with M2M application servers worldwide.

More information about oneM2M may be found at:  http//www.oneM2M.org

Copyright Notification

(c) 2024, oneM2M Partners Type 1 (ARIB, ATIS, CCSA, ETSI, TIA, TSDSI, TTA, TTC).

All rights reserved.

The copyright extends to reproduction in all media.



Notice of Disclaimer & Limitation of Liability

The information provided in this document is directed solely to professionals who have the appropriate degree of experience to understand and interpret its contents in accordance with generally accepted engineering or other professional standards and applicable regulations. No recommendation as to products or vendors is made or should be implied.

NO REPRESENTATION OR WARRANTY IS MADE THAT THE INFORMATION IS TECHNICALLY ACCURATE OR SUFFICIENT OR CONFORMS TO ANY STATUTE, GOVERNMENTAL RULE OR REGULATION, AND FURTHER, NO REPRESENTATION OR WARRANTY IS MADE OF MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR AGAINST INFRINGEMENT OF INTELLECTUAL PROPERTY RIGHTS. NO oneM2M PARTNER TYPE 1 SHALL BE LIABLE, BEYOND THE AMOUNT OF ANY SUM RECEIVED IN PAYMENT BY THAT PARTNER FOR THIS DOCUMENT, WITH RESPECT TO ANY CLAIM, AND IN NO EVENT SHALL oneM2M BE LIABLE FOR LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES. oneM2M EXPRESSLY ADVISES ANY AND ALL USE OF OR RELIANCE UPON THIS INFORMATION PROVIDED IN THIS DOCUMENT IS AT THE RISK OF THE USER.


# Contents  
[Contents](#contents)  
[1 Scope](#1-scope)  
[2 References](#2-references)  
&nbsp;&nbsp;&nbsp;&nbsp;[2.1 Normative references](#21-normative-references)  
&nbsp;&nbsp;&nbsp;&nbsp;[2.2 Informative references](#22-informative-references)   
[3 Definition of terms, symbols and abbreviations](#3-definition-of-terms-symbols-and-abbreviations)  
&nbsp;&nbsp;&nbsp;&nbsp;[3.1 Terms](#31-terms)  
&nbsp;&nbsp;&nbsp;&nbsp;[3.2 Symbols](#32-symbols)  
&nbsp;&nbsp;&nbsp;&nbsp;[3.3 Abbreviations](#33-abbreviations)  
[4 Conventions](#4-conventions)  
[5 User defined clause(s) from here onwards](#5-user-defined-clause\(s\)-from-here-onwards)  
&nbsp;&nbsp;&nbsp;&nbsp;[5.1 User defined subclause(s) from here onwards](#51-user-defined-subclause\(s\)-from-here-onwards)  
[Annex &lt;y>: Bibliography](#annex-&lt;y>:-Bibliography)  
[History](#history)

# 1 Scope
The present document ...

`EXAMPLE:    The present document provides the necessary adaptions to the endorsed document.`  

<mark>The Scope **shall not** contain requirements.</mark>


# 2 References
<mark>The following text block applies.</mark>

References are either specific (identified by date of publication and/or edition number or version number) or nonspecific. For specific references,only the cited version applies. For non-specific references, the latest version of the referenced document (including any amendments) applies.


## 2.1 Normative references



 
- <a name="_ref_1">[1]</a>    OGC SensorThings API "Part 1: Sensing Version 1.1" (http://www.opengis.net/doc/is/sensorthings/1.1)
- <a name="_ref_2">[2]</a>    oneM2M TS-0033 (V3.0.0): "Interworking Framework"

## 2.2 Informative references

<mark>Clause 2.2 shall only contain informative references which are cited in the document itself.</mark>

The following referenced documents are not necessary for the application of the present document but they assist the user with regard to a particular subject area.


- Use the **EX** style, add the letter "i" (for informative) before the number (which shall be in square brackets) and separate this from the title with a tab (you may use sequence fields for automatically numbering references).

- <a href="#_ref_i.1">[i.1]</a>    oneM2M Drafting Rules (http://www.onem2m.org/images/files/oneM2M-Drafting-Rules.pdf)
    


# 3 Definition of terms, symbols and abbreviations

<mark>Delete from the above heading the word(s) which is/are not applicable.</mark>


## 3.1 Terms

<mark>Clause numbering depends on applicability.</mark>

<mark>- A definition shall not take the form of, or contain, a requirement.</mark>  
<mark>- The form of a definition shall be such that it can replace the term in context. Additional information shall be given only in the form of examples or notes (see below).</mark>   
<mark>- The terms and definitions shall be presented in alphabetical order.</mark>

For the purposes of the present document, the [following] terms and definitions [given in ... and the following] apply:

<mark>Definition format</mark>

&lt;defined term>: &lt;definition>

<mark>If a definition is taken from an external source, use the format below where [N] identifies the external document which must be listed in Section 2 References.</mark>

&lt;defined term>[N]: &lt;definition>

example 1: text used to clarify abstract rules by applying them literally

> NOTE:    This may contain additional information.


## 3.2 Symbols

<mark>Clause numbering depends on applicability.</mark>

For the purposes of the present document, the [following] symbols [given in ... and the following] apply:

<mark>Symbol format</mark>

&lt;symbol>    &lt;Explanation>  
&lt;2nd symbol>    &lt;2nd Explanation>    
&lt;3rd symbol>    &lt;3rd Explanation>    


## 3.3 Abbreviations

<mark>Abbreviations should be ordered alphabetically.</mark>

<mark>Clause numbering depends on applicability.</mark>

For the purposes of the present document, the [following] abbreviations [given in ... and the following] apply:

<mark>Abbreviation format</mark>


&lt;ABREVIATION1>    &lt;Explanation>  
&lt;ABREVIATION2>    &lt;Explanation>  
&lt;ABREVIATION3>    &lt;Explanation>    

# 4 Conventions

The key words "Shall", "Shall not", "May", "Need not", "Should", "Should not" in this document are to be interpreted as described in the oneM2M Drafting Rules <a href="#_ref_i.1">[i.1]</a>


# 5 Introduction to OGC SensorThings API


The SensorThings API (STA) is a standard of the Open Geospatial Consortium (OGC). It provides a framework for communication and exchanging data between sensors and applications. The standard is devided in two parts. SensorThings API Part 1 is dedicated to sensing and was published in 2016 and updated in 2021 <a href="#_ref_1">[1]</a>.    
A STA-based architecture works in client/server mode. A sensor device pushes data to the SensorThings Server via HTTP. A SensorThings Server may also support MQTT protocol to support publish and subscribe capabilities. An interested application can subscribe to the MQTT-Broker, in order to get notified about new sensor events.

<figure>
  <img src="media/STA_flow.png" alt="STA_message_flow">
  <figcaption>Figure 5-1 STA message flow</figcaption>
</figure>

The data in the SensorThings server are organized as according to  **Sensing Entities** (see Figure 5.0-1: Sensing Entities data model <a href="#_ref_1">[1]</a>).

<figure>
  <img src="media/data_model.jpg" alt="data_model">
  <figcaption>Figure 5-1 STA Sensing Entities Data Model <a href="#_ref_1">[1]</a></figcaption>
</figure>

In the Sensing Entities Data Model events or sensor data are called "observations". Before a sensor is able to push an observation to the server it needs at least a 'Thing' and a 'Datastream' entity. This has to be created beforehand. One 'Thing' might have different 'Sensors', one 'Location' or many 'HistoricalLocations'.

The Sensing Entities data model and the purpose of data within the data model discloses mainly two data characteristics, associated with a 'thing':
-	Data observations originated by sensors or commands sent to interact with actuators may be seen as IoT data from oneM2M point of view.
	While: 
-	Data embedded in the Sensing Entities Data Model, like "historic locations" should be seen as data for documentation purposes.



# 6 Architecture Model of OGC/STA to oneM2M interworking

## 6.0 Introduction

Figure 6.0-1 shows an architecture approach for an Interworking Proxy Entity (IPE) between oneM2M and the OGC SensorThings API. The IPE is located between a oneM2M CSE and an OGC/SensorThings API (STA)-Server. 

The basic interworking enables applications that are connected to an oneM2M-based system to get data from sensors that are connected to an OGC/STA server. Furthermore, an application that is connected to an OGC/STA server will be able to get data from sensors that are connected to an oneM2M-based system.

<figure>
  <img src="media/STA_oneM2M_architekturbild_01.svg" alt="arch_overview">
  <figcaption>Figure 6.0-1: IPE architecture overview</figcaption>
</figure>

## 6.1 OGC/STA-to-oneM2M Data Model Mapping

According to oneM2M TS-0033 <a href="#_ref_2">[2]</a> a representation of a non-oneM2M Proximal IoT function/device in a oneM2M-specified resource instance is to be synchronized with the entity that it represents.

This means that the OGC/STA data model is represented in the hosting CSE. The data in the OGC/STA server are organized as Sensing Entities <a href="#_ref_1">[1]</a> (see Figure 5-2: STA Sensing Entities data model).

The oneM2M structure for data models is a tree-structure where data are organized in containers or trees of containers. 
The OGC/STA data model is a relational one, as used in databases, and not hierarchical. Thus, it creates a challenge for full interworking of all data captured in the OGC/STA data model. In this technical specification, only a limited set of data is mapped between OGC/STA and oneM2M.

<figure>
  <img src="media/ogc_non_model.png" alt="non_mapping">
  <figcaption>Figure 6.1-1: OGC data model cannot directly be mapped to oneM2M</figcaption>
</figure>

The SensorThings data model is comprehensive and may be regarded as a n:m relational database structure, holding both:
- sensor (IoT-data); and 
- administrative data (like historic locations or historic products IDs).

## 6.2 Architecture Approach

In order to transfer data from a oneM2M sensor to OGC/STA the IPE creates a <subscription> to the <container> resource with the desired data and when a new <contentInstance> is added it gets a <notification> message containing the <contentInstance> resource.
Figure 6.2-1 shows the oneM2M-to-OGC/STA direction. Based upon the creation of the <contentInstance> in the hosting CSE, the IPE gets a <notification> message including the <contentInstance>. The IPE constructs an "Observation" creation request and copies the 'content' attribute of the <contentInstance> to the 'result' attribute of the "Observation" shown in Figure 6.2-2 and sends it to the OGC/STA server.

<figure>
  <img src="media/onem2m_to_ogc_flow.png" alt="onem2m_to_ogc_flow">
  <figcaption>Figure 6.2-1: IPE oneM2M-to-OGC/STA direction</figcaption>
</figure>

<figure>
  <img src="media/content_copy.png" alt="content_to_observation_copy">
  <figcaption>Figure 6.2-2: Copying content from CIN to observation</figcaption>
</figure>

Figure 6.2-3 shows the OGC/STA-to-oneM2M direction. OGC/STA does not provide a publish/subscribe mechanism on HTTP protocol level, but OGC allows an optional MQTT extension for STA services <a href="#_ref_1">[1]</a>. The IPE subscribes to the MQTT-Broker of the OGC/STA server. The OGC/STA server publishes its new "Observation" via the MQTT broker. The IPE creates a <contentInstance> using a HTTP request and copies the 'result' attribute of the "Observation" to the 'content' attribute of the <contentInstance>. The <container> should be created beforehand at the hosting CSE where the IPE <contentInstance> resources are stored. All interested applications may subscribe to this <container> resource.

<figure>
  <img src="media/ogc_to_onem2m_flow.png" alt="ogc_to_onem2m_flow">
  <figcaption>Figure 6.2-3: IPE OGC/STA-to-oneM2M direction</figcaption>
</figure>

This approach is simple and sufficient in cases that only require translating "Observation" to <contentInstances> and vice-versa. Data are stored in the hosting CSE, but this is just a subset of the non-oneM2M proximal IoT function. These are only data that are being actually exchanged. The oneM2M client application is not able to gain additional information that are linked to an incoming "Observation" like "Location" or "Sensor". This kind of information would need to be exchanged upfront in the configuration phase described in clause 6.3. 


<mark>The following text is to be used when appropriate:</mark>


# Proforma copyright release text block
<mark>This text box shall immediately follow after the heading of an element (i.e. clause or annex) containing a proforma or template which is intended to be copied by the user. Such an element shall always start on a new page.</mark>


|Notwithstanding the provisions of the copyright clause related to the text of the present document, oneM2M grants that users of the present document may freely reproduce the &lt;proformatype> proforma in this {clause\|annex} so that it can be used for its intended purposes and may further publish the completed &lt;proformatype>.|  
|----|

<mark>&lt;PAGE BREAK></mark>


## <mark>Annexes</mark>
<mark>Each annex shall start on a new page (insert a page break between annexes A and B, annexes B and C, etc.).</mark>

<mark>Use the Heading 9 style for the title and the Normal style for the text.</mark>

# Annex &lt;A> (Informative/Normative):<mark>Remove Informative or Normative as appropriat</mark> Title of annex <mark>(style H9)</mark>

&lt;Text>  
<mark>&lt;PAGE BREAK></mark>

# Annex &lt;B> (Informative/Normative):<mark>Remove Informative or Normative as appropriat</mark> Title of annex <mark>(style H9)</mark>

&lt;Text>

## B.1    First clause of the annex <mark>(style H1)</mark>

&lt;Text>

### B.1.1    First subdivided clause of the annex <mark>(style H2)</mark>

&lt;Text>

<mark>&lt;PAGE BREAK></mark>

<mark>The following text is to be used when appropriate:</mark>

# Annex &lt;y>:<br />Bibliography
<mark>The annex entitled "Bibliography" is optional.</mark>

<mark>It shall contain a list of standards, books, articles, or other sources on a particular subject which are not mentioned in the document itself</mark>

<mark>It shall not include references mentioned in the document.</mark>

<mark>Use the Heading 9 style for the title and B1+ or Normal for the text.</mark>


- &lt;Publication>: "&lt;Title>".

OR

&lt;Publication>: "&lt;Title>".

<mark>&lt;PAGE BREAK></mark>


# History
<mark>This clause shall be the last one in the document and list the main phases (all additional information will be removed at the publication stage).</mark>


|Publication history |Publication history |Publication history |
|-|-|-|
|V1.x.x |&lt;yyyy-mm-dd > |&lt;Milestone> |
| | | |
| | | |
| | | |
| | | |








|Version (to be removed on publication) |Date (to be removed on publication) |Draft history (to be removed on publication) |
|-|-|-|
|V5.0.0 | 2024-03-01|Includes the following contributions agreed during SDS#58 meeting: 	SDS-2023-0219R01-initial_OGC_intro|
| | | |
| | | |
| | | |
| | | |
